/*
                 ,----------------, 
           ,-----------------------,
         ,"                      ,"|
        +-----------------------+  |
        |  .-----------------.  |  |
        |  |                 |  |  | 
        |  | Hack the Gibson |  |  |
        |- |      TERM       |  |  |
        |- |                 |  |  | 
        |- |                 |  |  | 
        |- `-----------------'  |,"
        +-----------------------+
           /_)______________(_/
      _______________________________ 
     /  oooooooooooooooo  .o.  oooo /|
    / ==ooooooooooooooo==.o.  ooo= // 
   /_==__==========__==_ooo__ooo=_/'
   `-----------------------------'

  Hack the Gibson TERM is GNU software
   please read ../COPYING for details

hgterm by Thea DeSilva
*/

#define MESH_WIDTH	  64 
#define MESH_HEIGHT	  64 
#define SMALL_AMOUNT	  0.1f 


#define	TITLED	          0
#define SEEMLESS_TITLED   1
#define SCALED	          2 
#define CENTER		  3


/* This is a background texture coord. 
 * Major refers to the texture in i_tid 
 * Minor refers to the actual opengl texture coords
 * For use in mesh vertex data
 */

typedef struct {
 int major_x, major_y; 
 float minor_x, minor_y;
} b_texcoord_t; 

extern float norm_neb[12]; /* normal vector lengths */

extern float bell_x, bell_y;
extern float find_place;

typedef struct {
 int neb[12];   /* neighbor offset */
 vect_t v;
 b_texcoord_t ts;
 int stuck;
 float tmp;
 int ta, tb, frame;
} b_point_t;

extern int cur_mesh;

typedef struct {
 int x_pad, y_pad;
 int x_num, y_num;
 int *i_tid;
 int tile;
 b_point_t *mesh[2];
} b_back_t;

extern b_back_t back1;

int _b_loadtex(char *filename, b_back_t *back);

int b_init(void);
int b_disp(void);
void b_tick(void);
