/*
                 ,----------------, 
           ,-----------------------,
         ,"                      ,"|
        +-----------------------+  |
        |  .-----------------.  |  |
        |  |                 |  |  | 
        |  | Hack the Gibson |  |  |
        |- |      TERM       |  |  |
        |- |                 |  |  | 
        |- |                 |  |  | 
        |- `-----------------'  |,"
        +-----------------------+
           /_)______________(_/
      _______________________________ 
     /  oooooooooooooooo  .o.  oooo /|
    / ==ooooooooooooooo==.o.  ooo= // 
   /_==__==========__==_ooo__ooo=_/'
   `-----------------------------'

  Hack the Gibson TERM is GNU software
   please read ../COPYING for details

hgterm by Thea DeSilva
*/



#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <fcntl.h>
#include "linkedlist.h"

#define 	CONN		0
#define 	NOT_CONN	1

int connfd, listenfd;


struct conn_t {
 struct list_head node;
 int connfd, x_fd, flag;
 int in_buf, pending;
 unsigned char in_buf_data[0xff];
};

struct conn_t *conns;

int buff[256], in_count;

typedef void (*sighandler_t)(int);

void sig_kill(void) {
 close(connfd);
 close(listenfd);
}

void sig_io(void) {
 printf("Some io\n");
}

void add_conn( int q_fd, int x_fd) {
 struct conn_t *tmp1, *tmp2, *new;
 new = (struct conn_t *)malloc(sizeof( struct conn_t) );
 list_add(&new->node, &conns->node);
 
 new->connfd = q_fd;
 new->x_fd = x_fd;
 new->in_buf = 0;
 new->flag = NOT_CONN;
}

void rm_conn( struct conn_t *rem) {
 struct conn_t *tmp2, *tmp; 
 if((int)rem == (int)conns) printf("Killing original\n");
 close(rem->connfd);
 close(rem->x_fd);
 list_del(&rem->node);
 free(rem);
 (int)rem = -1;
}

int con_pop_data( struct conn_t *con, unsigned char *buf, int count) {
/* int a,b,c,d;
 if(con->pending < count) a = con->pending else a = count; 
 for(b = 0; b< a; b++) {
//   buf[b] = con->in_buf_char[ con->in_buf - a 
 } */
}

void con_tick(void) {
 socklen_t len;
 int val, j, nobloc;
 unsigned char data;
 struct sockaddr_in servaddr, cliaddr, x_addr; 
 struct conn_t *walker, *tmp, *tmp2;
 

 connfd = accept( listenfd, (struct sockaddr *)&cliaddr, &len);

  if(connfd != -1) {
   add_conn( connfd, 12);
   val = fcntl( connfd, F_GETFL, 0);
   fcntl( connfd, F_SETFL, val | O_NONBLOCK);
  }

  walker = conns;

/*  
  for(;;) {
   if( (int)walker != -1) {
    j = read(walker->connfd, &data, sizeof(unsigned char) );
    if(j > 0) {
     walker->in_buf_char[walker->in_buf & 0xff ] = data;
     walker->in_buf++;
     walker->pending++; 
    } else
     if(j == 0) {
      printf("Connection closed\n");
      tmp = (struct conn_t *)walker->node.next;
      rm_conn(walker);
      walker = walker->node.next;
      break;
     }
   }
   walker = (struct conn_t *)walker->node.next;
   if((int)walker == (int)conns) break;
  }
*/
 
 /* connfd = accept( listenfd, (struct sockaddr *)&cliaddr, &len); 
  if(connfd != -1) {
   add_conn( connfd, 12);
   val = fcntl( connfd, F_GETFL, 0);
   fcntl( connfd, F_SETFL, val | O_NONBLOCK);
  }
  tmp = conns;
  walker = tmp;
  for(;;) {
   walker = (struct conn_t *)walker->node.next;
   if((int)walker == (int)tmp) break;
   if((int)walker != -1) {
    j = read( walker->connfd, &data, sizeof(unsigned char) );
    if( j > 0) 
     printf("Data on %d %d\n", walker->connfd, data);
    else
     if(j == 0) {
      printf("Connection %d closed\n", walker->connfd);
      tmp2 = (struct conn_t *)walker->node.next;
      rm_conn(walker);
      walker->node.next = tmp2;
     }
   }
  }

  */
 
}


int init_con(void) {
 socklen_t len;
 int val, j, nobloc;
 unsigned char data;
 struct sockaddr_in servaddr, cliaddr, x_addr; 
 struct conn_t *walker, *tmp;

 
 listenfd= socket(AF_INET, SOCK_STREAM, 0); 
 bzero( &servaddr, sizeof(servaddr) );
 servaddr.sin_family = AF_INET;
 servaddr.sin_addr.s_addr = htonl( 0x7f000001 );
 servaddr.sin_port = htons(6003); 


 bind(listenfd, (struct sockaddr *)&servaddr, sizeof(servaddr)); 

 listen(listenfd, 5);


 signal( SIGKILL, (sighandler_t)sig_kill);
 signal( SIGQUIT, (sighandler_t)sig_kill);
 signal( SIGHUP,  (sighandler_t)sig_kill);
 for(val =0; val < 256; val++) 
  buff[val] = -1;
 in_count = 0;

 conns = (struct conn_t *)malloc( sizeof( struct conn_t) );
 INIT_LIST_HEAD(&conns->node);
 
 conns->connfd = -1;
 conns->x_fd = -1;
 conns->flag = CONN;
 conns->in_buf = 0; 
 conns->pending = 0; 

 val = fcntl( listenfd, F_GETFL, 0);
 fcntl(listenfd, F_SETFL, val | O_NONBLOCK); 


}
