/*
                 ,----------------, 
           ,-----------------------,
         ,"                      ,"|
        +-----------------------+  |
        |  .-----------------.  |  |
        |  |                 |  |  | 
        |  | Hack the Gibson |  |  |
        |- |      TERM       |  |  |
        |- |                 |  |  | 
        |- |                 |  |  | 
        |- `-----------------'  |,"
        +-----------------------+
           /_)______________(_/
      _______________________________ 
     /  oooooooooooooooo  .o.  oooo /|
    / ==ooooooooooooooo==.o.  ooo= // 
   /_==__==========__==_ooo__ooo=_/'
   `-----------------------------'

  Hack the Gibson TERM is GNU software
   please read ../COPYING for details

hgterm by Thea DeSilva
*/

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <math.h>
#include <GL/gl.h>
#include <SDL.h>

#include "include.h"

f_color_t f_default_color;
f_color_t f_default_color_bg;
f_plane_t *f_screen_plane;
#ifdef UNDUMP
 f_plane_t *test_plane;
#endif
 
f_plane_t *f_planes[256];

int f_pushchar(char *c, f_plane_t *plane, int len) {
 int i;
 if(len + plane->buf_in_tail > 1024)
  return 0;		//  Buffer full
 memcpy(&plane->buf_in[ plane->buf_in_tail], (void *)c, len);
 plane->buf_in_tail+=len;
}

int f_popchar(char *c, f_plane_t *plane, int len) {
 int i;
 if(!c) c = (char *)malloc(1024);
 for(i=0;;i++) {
  c[i] = plane->buf_in[ plane->buf_in_head];
  plane->buf_in_head++;
  if(i == len) break;
  if(plane->buf_in_head == plane->buf_in_tail) {
   plane->buf_in_head  = 0;
   plane->buf_in_tail = 0;
   break;
  }
 }
 return i; 
}

void _f_putchar(char c, int x, int y, float xsize, float ysize, int start_x, int start_y,  f_plane_t *plane) {
 float xi, yi;
 int i,j, sj, age;
 glEnable(GL_BLEND);
 glDisable(GL_DEPTH_TEST);
 glBlendFunc(GL_SRC_ALPHA,GL_ONE);
 glEnable(GL_TEXTURE_2D);
 glBindTexture(GL_TEXTURE_2D, t_tid[FONT]);
 j =  T2L(x, (y+plane->disp_start) % SCROLL_BUF, plane->x); 
 sj = T2L(x, y, plane->x);
 
 if( c!= 129) {
  if(plane->data[j].c != plane->screen[sj].c) plane->screen[sj].age = 6;
  plane->data[j].c = c;
  plane->screen[sj].c = c;
 }

 if(c==' ') return;
 c-=33;
 xi = (float)(c % 16) / 16.0f;
 yi = (float)(c / 16) / 16.0f; 
 glColor4f( plane->fg.r, plane->fg.g, plane->fg.b, plane->fg.a );
 if( c!= 129) {
  if(plane->screen[sj].age>6) plane->screen[sj].age = 6;
  if(plane->screen[sj].age<2) plane->screen[sj].age = 2;
  plane->screen[sj].age--;
  age = plane->screen[sj].age;
 } else 
  age = 4;
 
 glBegin(GL_QUADS); 
  for(i = 0; i< age ; i++) { 
   glTexCoord2f( xi, yi); 
   
   glVertex3f(
              (float)( (x * (xsize/2) )  - (i *2)) + start_x, 
	      (float)( (y *  ysize) - (i *2)) + start_y, 		0.0f);
   
   glTexCoord2f( xi + (1.0f/16.0f), yi);
   
   glVertex3f(
              (float)( ((x * (xsize/2))+ xsize) + (i *2)) + start_x,
	      (float)( (y *   ysize) - (i *2)) + start_y,		 0.0f);
   
   glTexCoord2f( xi + (1.0f/16.0f), yi + (1.0f/16.0f));
   
   glVertex3f(
              (float)( ((x * (xsize/2))+xsize) + (i *2)) + start_x,
	      (float)( ( (y * ysize) + ysize )+ (i *2)) + start_y	,0.0f);
   
   glTexCoord2f( xi, yi + (1.0f/16.0f) );
   
   glVertex3f(
              (float)( (x * ( xsize/2) ) - (i *2)) + start_x, 
	      (float)( ( (y * ysize) + ysize ) + (i *2)) + start_y	,0.0f); 
  } 
 glEnd();

}

void f_init(void) {
 char buf[256];
 int i;
 t_file2tex("/var/font.jpeg", &t_tid[FONT]); 
 f_default_color.r = 0.3f;
 f_default_color.g = 1.0f;
 f_default_color.b = 0.3f;
 f_default_color.a = 1.0f;
 f_default_color_bg.r = 0.0f;
 f_default_color_bg.g = 0.0f;
 f_default_color_bg.b = 0.0f;
 f_default_color_bg.a = 0.5f;
 f_default_color.age = 0;
 for(i=0;i<256;i++)
  f_planes[i] = (f_plane_t *)-1;
 
 f_screen_plane = f_register_plane(130, 47, 0, 0, d_width, d_height, VISIBLE, 4);
#ifdef UNDUMP
 test_plane = f_register_plane(strlen(" (0xXX: ? ) "), 1, 200, 200, 450, 250, VISIBLE, 3);
#endif
// f_register_plane(30, 5, 100, 100, 400, 200, NOTVISIBLE, 1);
// s_register(1, f_tick, CALLBACK);
// s_ssync(f_tick, ENABLE, CALLBACK);
 active_window = 2;
}

void f_scroll_down(f_plane_t *plane) {
 int i, j;
 plane->window.cury--;
 wscroll(&plane->window, S_DOWN, plane);
 return;
}

void f_move_cursor(f_plane_t *plane, int dir) {
 switch(dir) {
  case UP: 
   plane->window.cury--;
   if(plane->window.cury<plane->window.sy1) {
    plane->window.cury=plane->window.sy1;
    plane->window.curx=0;
   }
   break;
  case DOWN:
   plane->window.cury++;
   if(plane->window.cury == (plane->window.sy2 + 1)  )
    f_scroll_down(plane);
   else 
    if(plane->window.cury == plane->y) {
     plane->window.cury--;
     plane->window.curx = 0;
    }
   break;
  case LEFT:
   plane->window.curx--;
   if(plane->window.curx < 0) {
    plane->window.curx = plane->x - 1;
    f_move_cursor(plane, UP);
   }
   break;
  case RIGHT:
   plane->window.curx++;
   if(plane->window.curx > plane->x -1) {
    plane->window.curx = 0;
    f_move_cursor(plane,DOWN);
   }
   break;
  case HOME:
   plane->window.curx = 0;
   plane->window.cury = 0;
   break;
  case CAR:
   plane->window.curx = 0;
   break;
 }
 plane->window.curx = plane->window.curx;
 plane->window.cury = plane->window.cury;
 
}

/* Output a raw character to a plane, control characters are understood */

void f_char(char c, f_plane_t *plane) {
 int i,j;
 switch(c) {
  case NUL:
   break;
  case BEL:
   d_bell();
   break;
  case BS:
   f_move_cursor(plane, LEFT);
   plane->data[T2L(plane->window.curx, (plane->window.cury+plane->disp_start) % SCROLL_BUF, plane->x)].c = 200;
   break;
  case HT:
   j = 8 - ((plane->window.curx) % 8);
   for(i=0;i<j;i++)
    f_move_cursor(plane, RIGHT);
//   f_ansi_char(ESC, plane);
   break;
  case LF:
   f_move_cursor(plane, CAR);
   f_move_cursor(plane, DOWN);
   break;
  case VT:
   f_move_cursor(plane, HOME);
   break;
  case CR:
   f_move_cursor(plane, CAR);
   break;
  case ESC:
   plane->data[T2L(plane->window.curx, (plane->window.cury+plane->disp_start) % SCROLL_BUF, plane->x)].c = 'E';
   f_move_cursor(plane, RIGHT);
   break; 
  default:
   if(c > 31 && c < 128) {
    plane->data[T2L(plane->window.curx, (plane->window.cury+plane->disp_start) % SCROLL_BUF, plane->x)].c = c;
    f_move_cursor(plane, RIGHT);
    break;
   } else
    break;
 }
 
}

/* Output an ansi character to plane, ansi sequences are understood */

/* XXX finish this sometime */

void f_ansi_char(char c, f_plane_t *plane) {
 vt_out(c, plane);
}

void f_move_plane(f_plane_t *plane, int x, int y, int x2, int y2) {
 m_ent_t *obj[2];
 obj[0] = plane->mov_obj[TOP_LEFT];
 obj[1] = plane->mov_obj[BOT_RIGHT];
 obj[0]->find.x = x;
 obj[0]->find.y = y;
 obj[1]->find.x = x2;
 obj[1]->find.y = y2;
 obj[0]->done = 0;
 obj[1]->done = 0;
}

void f_hide_plane(f_plane_t *plane) {
 m_ent_t *obj[2];
 float distx, disty;
 obj[0] = plane->mov_obj[TOP_LEFT];
 obj[1] = plane->mov_obj[BOT_RIGHT];
 if(obj[0]->find.x == obj[1]->find.x && obj[1]->find.y == obj[0]->find.y) 
  return;

 plane->wake_x1 = obj[0]->find.x;
 plane->wake_y1 = obj[0]->find.y;
 plane->wake_x2 = obj[1]->find.x;
 plane->wake_y2 = obj[1]->find.y;

 disty = ((obj[1]->find.y - obj[0]->find.y) / 2.0f);
 distx = ((obj[1]->find.x - obj[0]->find.x) / 3.0f);

 obj[0]->find.x += distx;
 obj[1]->find.x -= distx;
 obj[0]->find.y += disty;
 obj[1]->find.y -= disty;
 
 obj[0]->done = 0;
 obj[1]->done = 0;
 plane->waking = 0;
}

 void f_show_plane(f_plane_t *plane) {
  m_ent_t *obj[2];
  plane->visible = 1;
  plane->waking = 1;

  obj[0] = plane->mov_obj[TOP_LEFT];
  obj[1] = plane->mov_obj[BOT_RIGHT]; 
  obj[0]->find.x = plane->wake_x1;
  obj[0]->find.y = plane->wake_y1;
  obj[1]->find.x = plane->wake_x2;
  obj[1]->find.y = plane->wake_y2;

  obj[0]->done = 0;
  obj[1]->done = 0;
 }

/* see which is higher */

int _f_compare_planes( f_plane_t **a, f_plane_t **b) {
 f_plane_t *q, *j;
 q = *a;
 j = *b;

 
 if( q->z > j->z  || ( (int)*a == -1 && (int)*b != -1)  ) return 1; else
  if(q->z < j->z  || ( (int)*a != -1 && (int)*b == -1)  ) return -1; else
   return 0;
}

void _f_sort_planes(void) {
 qsort( (void **)f_planes, 256, sizeof(f_plane_t), (void *)_f_compare_planes);
}

 f_plane_t *f_register_plane(int x, int y, int px, int py, int px2, int py2, int visible, int z) {
  int qx, qy;
  vect_t mov;
  f_plane_t *ret;
  int i;
  ret = (f_plane_t *)malloc(sizeof(f_plane_t));
  for(i=0;i<256;i++)
   if((int)f_planes[i] == -1)  {
    f_planes[i] = ret;
    break;
   }
  ret->data =   malloc( sizeof(f_char_t) * x * SCROLL_BUF);
  ret->screen = malloc( sizeof(f_char_t) * x * y);
  ret->visible = visible;
  ret->waking = 0;
  ret->x = x;
  ret->y = y;
  ret->window.curx = 0;
  ret->window.cury = 0;
  ret->window.sy1 = 0;
  ret->window.sy2 = y;
  ret->window.x1 = 0; 
  ret->window.x2 = x;
  ret->window.y1 = 0;
  ret->window.y2 = y;
  ret->vt100.newy1 = 0;
  ret->vt100.newy2 = y;
  ret->window.xs = x;
  ret->window.ys = y;
  ret->history = 0;
  ret->disp_start = 0;
  vt_install(&ret->window, ret);
  vt_init(ANSI, WHITE, BLACK, 0, 0, ret );
  vt_pinit(&ret->window, x, y, ret);
  for(qy = 0; qy < SCROLL_BUF; qy++)
   for(qx = 0; qx < x; qx++) {
    ret->data[T2L(qx, qy, x)].c = 200;
    if(qy < y) {
     ret->screen[T2L(qx, qy, x)].c = 200;
     ret->screen[T2L(qx, qy, x)].age = 0;
    }
   }
  ret->buf_in_head =0;
  ret->buf_in_tail =0;
  ret->buf_out_head = 0;
  ret->buf_out_tail = 0;
  ret->mov_obj[TOP_LEFT] =  m_register( px + ((px2 - px) / 48), ((py2 - py) /2) + py, 0);
  ret->mov_obj[BOT_RIGHT] = m_register( px2 -((px2 - px) / 48), ((py2 - py) /2) + py, 0);

  mov.z = 0;
  mov.x = px;
  mov.y = py;
  m_mov( &mov, ret->mov_obj[TOP_LEFT] );
  mov.x = px2;
  mov.y = py2;
  m_mov( &mov, ret->mov_obj[BOT_RIGHT] );
  
  memcpy(&ret->fg, &f_default_color, sizeof(f_color_t) );
  memcpy(&ret->bg, &f_default_color_bg, sizeof(f_color_t) );

  f_ansi_char('\33', ret);
  f_ansi_char('[', ret);
  f_ansi_char('r', ret);

 
//  _f_sort_planes(); 
  return ret;
 }

 void f_free_plane(f_plane_t *ret) {
  int i;
 // for(i=0;i<ret->x * ret->y;i++) 
 //  free(ret->data[i]);
  free(ret->data);
  free(ret); 
 }

 void f_draw_planes(void) {
  int i;
  m_ent_t *obj[2];
 for(i=0;i<256;i++) {
  if((int)f_planes[i] != -1) {
   obj[0] = f_planes[i]->mov_obj[TOP_LEFT];
   obj[1] = f_planes[i]->mov_obj[BOT_RIGHT];
   if(f_planes[i]->visible == 1) {
    if( fabs( (float)obj[0]->pos.y - (float)obj[1]->pos.y) > 1.0f)
     f_draw_plane(f_planes[i]);
    else
     f_planes[i]->visible = 0;
   } else {
    if( fabs( (float)obj[0]->pos.y - (float)obj[1]->pos.y) < 1.0f) {
     if( f_planes[i]->waking == 1) {
      f_planes[i]->visible = 1;
      f_planes[i]->waking = 0;
     } 
    }
   }
  }
 }
}

void f_draw_plane(f_plane_t *plane) {
 int qx, qy;
 int x, y, x2, y2;
 float xsize, ysize;
 m_ent_t *obj[2];
 obj[0] = plane->mov_obj[TOP_LEFT];
 obj[1] = plane->mov_obj[BOT_RIGHT];
 x = (int)obj[0]->pos.x;
 y = (int)obj[0]->pos.y;
 x2= (int)obj[1]->pos.x;
 y2= (int)obj[1]->pos.y;
 glEnable(GL_BLEND);
 glDisable(GL_DEPTH_TEST);
 glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
 glDisable(GL_TEXTURE_2D);
 glColor4f(plane->bg.r, plane->bg.b, plane->bg.g, plane->bg.a); 
 glBegin(GL_QUADS);
  glVertex3f(x, y, 0);
  glVertex3f(x2, y, 0);
  glVertex3f(x2, y2, 0);
  glVertex3f(x, y2,0);
 glEnd();
 xsize = (float)( ((x2 - x) * 2) / (float)(plane->x+1));
 ysize = (float)( y2 -y) / (float)plane->y;
 for(qy=0;qy<plane->y;qy++)
  for(qx=0;qx<plane->x;qx++) 
   if(plane->data[T2L(qx,(qy+plane->disp_start) % SCROLL_BUF, plane->x)].c != 200)
    _f_putchar(plane->data[T2L(qx, (qy+plane->disp_start) % SCROLL_BUF, plane->x)].c, qx, qy, xsize, ysize , x, y, plane);
   else
    plane->data[T2L(qx, (qy+plane->disp_start) % SCROLL_BUF, plane->x)].age = 0;
   if(cblink & 1 == 1)  
    _f_putchar(129, plane->window.curx, plane->window.cury, xsize, ysize, x,y,  plane);
 
  
}
