/*
                 ,----------------, 
           ,-----------------------,
         ,"                      ,"|
        +-----------------------+  |
        |  .-----------------.  |  |
        |  |                 |  |  | 
        |  | Hack the Gibson |  |  |
        |- |      TERM       |  |  |
        |- |                 |  |  | 
        |- |                 |  |  | 
        |- `-----------------'  |,"
        +-----------------------+
           /_)______________(_/
      _______________________________ 
     /  oooooooooooooooo  .o.  oooo /|
    / ==ooooooooooooooo==.o.  ooo= // 
   /_==__==========__==_ooo__ooo=_/'
   `-----------------------------'

  Hack the Gibson TERM is GNU software
   please read ../COPYING for details

hgterm by Thea DeSilva
*/

#define	SCROLL_BUF	1024
#define UP		1
#define DOWN		2
#define LEFT		3
#define RIGHT		4
#define CAR		5
#define HOME		6

#define NUL		0
#define BEL		7
#define BS		8
#define HT		9
#define LF		10
#define VT		11
#define CR		13
#define ESC		27

#define VISIBLE		1
#define NOTVISIBLE	0

typedef struct { 
 float r, g, b, a;
 int age;
} f_color_t;

typedef struct { 
 int age;
 unsigned char a, c; 
} f_char_t; 

typedef struct {
 int x, y, z; 
 int visible;
 int wake_x1, wake_y1;
 int wake_x2, wake_y2;
 int waking;
 f_color_t fg, bg;
 int history;
 int disp_start;
 f_char_t *screen;
 f_char_t *data;
 vt100_t vt100;
 WIN window;
 unsigned char  buf_in[1024];
 int buf_in_head, buf_in_tail;
 unsigned char buf_out[1024];
 int buf_out_head, buf_out_tail;
 void *mov_obj[4];
 
 
} f_plane_t;


extern f_color_t f_default_color;
extern f_color_t f_default_color_bg;
extern f_plane_t *f_screen_plane;

#ifdef UNDUMP
 extern f_plane_t *test_plane;
#endif

extern f_plane_t *f_planes[256];

int f_pushchar(char *c, f_plane_t *plane, int len);

void _f_putchar(char c,int x, int y, float xsize, float ysize, int start_x, int start_y, f_plane_t *plane);

void f_init(void);

void f_char(char c, f_plane_t *plane);

void f_ansi_char(char c, f_plane_t *plane);

void f_mov_plane(f_plane_t *plane, int x, int y, int x2, int y2);

void f_hide_plane(f_plane_t *plane);
void f_show_plane(f_plane_t *plane);

f_plane_t *f_register_plane(int x, int y, int px, int py, int px2, int py2, int visible, int z);

void f_free_plane(f_plane_t *ret);

void f_draw_planes(void);

void f_draw_plane(f_plane_t *plane);

void f_move_cursor(f_plane_t *plane, int dir); 

