/*
                 ,----------------, 
           ,-----------------------,
         ,"                      ,"|
        +-----------------------+  |
        |  .-----------------.  |  |
        |  |                 |  |  | 
        |  | Hack the Gibson |  |  |
        |- |      TERM       |  |  |
        |- |                 |  |  | 
        |- |                 |  |  | 
        |- `-----------------'  |,"
        +-----------------------+
           /_)______________(_/
      _______________________________ 
     /  oooooooooooooooo  .o.  oooo /|
    / ==ooooooooooooooo==.o.  ooo= // 
   /_==__==========__==_ooo__ooo=_/'
   `-----------------------------'

  Hack the Gibson TERM is GNU software
   please read ../COPYING for details

hgterm by Thea DeSilva
*/

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <GL/gl.h>
#include <SDL.h>


#include "include.h"

#define BOOT_UP		1
#define BOOT_DONE	2

f_plane_t *input_plane;
int state, i, j, k;
FILE *logo_fp;

void i_tick(void) {
 if(i == 0) {
  f_char(':', input_plane);
  i++;
 }
}

void i_intro(void) {
 unsigned char dat;
 int q;
 if(state == BOOT_UP) {
  for(q = 0; q< 5; q++) 
   if(i < j) {
    fread(&dat, 1, 1, logo_fp);
    f_char( dat, input_plane);
    i++; 
   } else {
    state = BOOT_DONE;
    s_sleep(i_intro, 70);
   }
  } else {
   if(k==0) {
    f_hide_plane(input_plane);
    s_ssync(i_intro, DISABLE, CALLBACK);
    k++;
    s_register(1, i_tick, CALLBACK);
    s_ssync(i_tick, ENABLE,CALLBACK);
    s_ssync(i_intro, DISABLE, CALLBACK);
//    s_deregister(i_intro, CALLBACK);
    i = 0;
   } 
  }
}


void i_init(void) {
 struct stat st;
 input_plane = f_register_plane(40, 23, (d_width/2)- (400/2), (d_height/2) - (300/2), (d_width/2) + (400/2) , (d_height/2)+ (300/2), VISIBLE, 3);
 state = BOOT_UP;
 logo_fp = fopen("/root/hgterm2/logo", "rb");
 fstat(fileno(logo_fp), &st);
 j = st.st_size;
 i = 0;
 k = 0;
 
 s_register( 1, i_intro, CALLBACK);
 s_ssync(i_intro, ENABLE, CALLBACK);
}
