/*
                 ,----------------, 
           ,-----------------------,
         ,"                      ,"|
        +-----------------------+  |
        |  .-----------------.  |  |
        |  |                 |  |  | 
        |  | Hack the Gibson |  |  |
        |- |      TERM       |  |  |
        |- |                 |  |  | 
        |- |                 |  |  | 
        |- `-----------------'  |,"
        +-----------------------+
           /_)______________(_/
      _______________________________ 
     /  oooooooooooooooo  .o.  oooo /|
    / ==ooooooooooooooo==.o.  ooo= // 
   /_==__==========__==_ooo__ooo=_/'
   `-----------------------------'

  Hack the Gibson TERM is GNU software
   please read ../COPYING for details

hgterm by Thea DeSilva
*/

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <GL/gl.h>
#include <SDL.h>
#include <SDL_image.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/un.h>
#include <string.h>
#include <fcntl.h>
#include <pty.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <signal.h>

#include "include.h"


#define SU(su)  (sizeof( su ) - sizeof( su.sun_path ) + strlen( su.sun_path ))

int qfd;
int priority, test_id;

float logo_alpha;

int main2(void) {
 int dat_count;
 char buf[128];
 int buf2;
 int rlen;
 socklen_t len;
 unsigned char dat;
 int ll;
 unsigned char bufff[256];
 struct sockaddr_un serveraddr, cliaddr;
 char buff[128];
 FILE *qq;
 int slavetty, mastertty;
 struct winsize ws;
#ifdef UNDUMP
 char dump_textbuf[50];
 int dump_i;
 Uint8 wait_for_enter;
 FILE *temp_dump;
 temp_dump = fopen("/tmp/hgterm.dump", "rb");
 if(!temp_dump) { perror("/tmp/hgterm.dump"); exit(-1); }
#endif


#ifdef DUMP
 FILE *temp_dump;
 temp_dump = fopen("/tmp/hgterm.dump", "wb");
#endif

 chdir("/root");

 shell_init(); 
 shell_new("/bin/sh", 80, 25);
  
 dat_count = 0;
 ws.ws_xpixel = 0;
 ws.ws_ypixel = 0;
 ws.ws_col = 130;
 ws.ws_row = 47;

 if(!openpty( &mastertty, &slavetty, NULL , NULL, &ws)) 
  perror("openpty");
 
 if(fork() == 0) {
  sleep(1);
  login_tty(slavetty);
  dup2(slavetty, fileno(stdin));
  dup2(slavetty, fileno(stdout));
  dup2(slavetty, fileno(stderr));

#ifdef DUMP
  execlp("/bin/bash", "bash", "/var/tovttest", (char *)0);
#else
  execlp("/bin/bash", "bash", "/var/toscreen",  (char *)0);
#endif
  
 } else 
  qfd = mastertty; 
 

 d_init(1024-150,768-150, 16);  /* initialize display, disp.c */
 s_init();               /* initialize sync system, sync.c */

 /*
  * Load logo and initialize state, rest handled in disp.c 
  */
 if(!t_file2tex("/root/hgterm2/ds/logo.jpg", &t_tid[GRAPHIC])) { e_push("t_file2tex"); return 0; } 

// b_init();               /* initialize background state, back.c      */
 m_init();
 f_init();		 /* initialize font system, font.c           */
 i_init();
 td_init();
 
 init_con();

 

 
 /* all sound stuff */
 init_snd(DIGI_OSS);

 snd_load(SD_RET, "/var/hgterm_ret.wav");
 snd_load(SD_REC, "/var/hgterm_rec.wav");
 snd_load(SD_TICK,"/var/hgterm_tick.wav");

 
 buf2 = getpid();
 
 s_set(INIT | ENABLE_THEM);   /* create and start sync interrupts, sync.c */

 f_pushchar("my name is thea", f_screen_plane, sizeof("my name is thea"));
// printf("%d\n", get_id_from_salt( 88 ));
 
#ifdef UNDUMP
 dump_i = 0;
#endif

 for(;;) {
  con_tick();
#ifdef UNDUMP
  fread(&dat, 1, 1, temp_dump);
/*
  for(;;) {
   wait_for_enter = d_pullkey();
   if(wait_for_enter != KEY_BUF_EMPTY) 
    if(wait_for_enter == '\r') break;
  } 
*/
 f_ansi_char(dat, f_screen_plane); 
 
 sprintf(dump_textbuf," (0x%02x: ", dat);
 for(dump_i=0;dump_i< strlen("(0xxx: ");dump_i++)
  f_ansi_char(dump_textbuf[dump_i], test_plane);
 if(dat == '\r') dat = 'R';
 if(dat == '\n') dat = 'N';
 if(dat == 27  ) dat = 'E'; 
 sprintf(dump_textbuf, "%c )\r", dat);
 for(dump_i=0;dump_i< strlen("x  r");dump_i++)
  f_ansi_char(dump_textbuf[dump_i], test_plane);
#else
  if(read(qfd, &dat, sizeof(unsigned char))>0) {
#ifdef DUMP
  fwrite(&dat, 1, 1, temp_dump); 
#endif
   if(dat_count == 100) { dat_count = 0; make_sound(SD_REC); }
   dat_count++;
   f_ansi_char(dat, f_screen_plane); 
  }
#endif
 }
 
 SDL_Quit();
 return 1;
}

int main(void) {
 priority =  getpriority(PRIO_PROCESS, 0);
 if(!main2()) { e_push("main"); e_print(); return -1; }
 return 1;
}

END_OF_MAIN();
