/*
                 ,----------------, 
           ,-----------------------,
         ,"                      ,"|
        +-----------------------+  |
        |  .-----------------.  |  |
        |  |                 |  |  | 
        |  | Hack the Gibson |  |  |
        |- |      TERM       |  |  |
        |- |                 |  |  | 
        |- |                 |  |  | 
        |- `-----------------'  |,"
        +-----------------------+
           /_)______________(_/
      _______________________________ 
     /  oooooooooooooooo  .o.  oooo /|
    / ==ooooooooooooooo==.o.  ooo= // 
   /_==__==========__==_ooo__ooo=_/'
   `-----------------------------'

  Hack the Gibson TERM is GNU software
   please read ../COPYING for details

hgterm by Thea DeSilva
*/

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <GL/gl.h>
#include <SDL.h>
#include <SDL_image.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/un.h>
#include <string.h>
#include <fcntl.h>
#include <pty.h>

#include "include.h"

m_ent_t m_objs[128];

void *m_register(float x, float y, float z) {
 int slot;
 for(slot = 0; slot < 128; slot++)
  if(m_objs[slot].free == 0) goto done;
 printf("out of movs\n");
 exit(-1);
done: 
 m_objs[slot].free = 2;
 m_objs[slot].find.x = x;
 m_objs[slot].find.y = y;
 m_objs[slot].find.z = z;
 m_objs[slot].done = 1;
 m_objs[slot].pos.x = x;
 m_objs[slot].pos.y = y;
 m_objs[slot].pos.z = z;
 return &m_objs[ slot ]; 
}

void m_mov(vect_t *to, m_ent_t *obj) {
 obj->find.x = to->x;
 obj->find.y = to->y;
 obj->find.z = to->z;
 obj->done = 0;
}

void m_tick(void) {
 int slot;
 float dist, q;
 vect_t vect, vect2;
 dist = (1.0f/15.0f);
 for(slot = 0; slot < 128; slot++)  
  if(m_objs[slot].free == 2 && m_objs[slot].done == 0) {
   points2vect( &m_objs[slot].find, &m_objs[slot].pos, &vect);
   if(fabs((vect.x + vect.y + vect.z))<0.1f) 
    m_objs[slot].done = 1;
   else {
    mul_vect(&vect, &dist, &vect2);
    add_vect(&m_objs[slot].pos, &vect2, &m_objs[slot].pos);
   }
  }
}

void m_init(void) {
 int i;
 for(i=0;i<128; i++) {
  m_objs[i].free = 0; 
  m_objs[i].done = 1;
 }
 s_register(1, m_tick, CALLBACK); 
 s_ssync( m_tick, ENABLE, CALLBACK);
}

