/*
                 ,----------------, 
           ,-----------------------,
         ,"                      ,"|
        +-----------------------+  |
        |  .-----------------.  |  |
        |  |                 |  |  | 
        |  | Hack the Gibson |  |  |
        |- |      TERM       |  |  |
        |- |                 |  |  | 
        |- |                 |  |  | 
        |- `-----------------'  |,"
        +-----------------------+
           /_)______________(_/
      _______________________________ 
     /  oooooooooooooooo  .o.  oooo /|
    / ==ooooooooooooooo==.o.  ooo= // 
   /_==__==========__==_ooo__ooo=_/'
   `-----------------------------'

  Hack the Gibson TERM is GNU software
   please read ../COPYING for details

hgterm by Thea DeSilva
*/
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <GL/gl.h>
#include <SDL.h>
#include <SDL_image.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/un.h>
#include <string.h>
#include <fcntl.h>
#include <pty.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <signal.h>

#include "include.h"


void SIGNAL_io(int a, siginfo_t *b, void *c) {
 printf("io on %d\n", b->si_fd); 
}


shell_shell_t shells;

void shell_init(void) {
 struct sigaction temp_sig;
 INIT_LIST_HEAD(&shells.node); 
 temp_sig.sa_sigaction = SIGNAL_io;
 temp_sig.sa_flags = SA_SIGINFO;
 sigaction(SIGIO, &temp_sig, NULL); 
}

void shell_new(char *cmd, int w, int h) {
 unsigned char dat;
 struct winsize ws;
 int slave, master, i;
 shell_shell_t *new;
 new = (shell_shell_t *)malloc(sizeof(shell_shell_t) );
 list_add(&new->node, &shells.node);
 new->w = w;
 new->h = h;
 ws.ws_xpixel =0;
 ws.ws_ypixel =0;
 ws.ws_col = w;
 ws.ws_row = h;
 if(!openpty( &master, &slave, NULL, NULL, &ws) )
  perror("Beat");
 
 new->cmd_pid = fork();
 
 if(new->cmd_pid == 0) {
  sleep(1);
  login_tty(slave);
  dup2(slave, fileno(stdin) );
  dup2(slave, fileno(stdout));
  dup2(slave, fileno(stderr));
  execlp("/bin/bash", "bash", "/var/tovttest", (char *)0);
 
 } else {
  new->master_tty = master; 
 }
 
}
