/*
                 ,----------------, 
           ,-----------------------,
         ,"                      ,"|
        +-----------------------+  |
        |  .-----------------.  |  |
        |  |                 |  |  | 
        |  | Hack the Gibson |  |  |
        |- |      TERM       |  |  |
        |- |                 |  |  | 
        |- |                 |  |  | 
        |- `-----------------'  |,"
        +-----------------------+
           /_)______________(_/
      _______________________________ 
     /  oooooooooooooooo  .o.  oooo /|
    / ==ooooooooooooooo==.o.  ooo= // 
   /_==__==========__==_ooo__ooo=_/'
   `-----------------------------'

  Hack the Gibson TERM is GNU software
   please read ../COPYING for details

hgterm by Thea DeSilva
*/

#include <GL/gl.h>
#include <GL/glu.h>
#include <SDL.h>
#include "include.h"

extern int test_id;

td_t *tds[1024];
float rotate;

void td_tick(void) {
 rotate+=1.0f;
}

void td_init(void) {
 tds[0] = td_register_td( 30, 30, 1000, 700, VISIBLE);
 rotate = 1;
 s_register(1, td_tick, CALLBACK);
 s_ssync(td_tick, ENABLE, CALLBACK);
}

td_t *td_register_td(int px, int py, int px2, int py2, int visible) {
 vect_t mov;
 td_t *ret;
 ret = (td_t *)malloc(sizeof(td_t));
 /* XXX 48 and 2 are magic numbers that define how a window, or whatever, grows to it's full size */
 ret->mov_obj[TOP_LEFT] =  m_register( px + ((px2 - px) / 48), ((py2 - py) /2) + py, 0);
 ret->mov_obj[BOT_RIGHT] = m_register( px2 -((px2 - px) / 48), ((py2 - py) /2) + py, 0);

 mov.z = 0;
 mov.x = px;
 mov.y = py;
 m_mov( &mov, ret->mov_obj[TOP_LEFT] );
 mov.x = px2;
 mov.y = py2;
 m_mov( &mov, ret->mov_obj[BOT_RIGHT] );
 return ret;
}

void td_draw_td(td_t *td) {
 m_ent_t *obj[2];
 GLdouble clips[4][4];
 obj[0] = (m_ent_t *)td->mov_obj[TOP_LEFT];
 obj[1] = (m_ent_t *)td->mov_obj[BOT_RIGHT];

 /*
 clips[CLIP_LEFT][0] = 1.0f;
 clips[CLIP_LEFT][1] = 0.0f;
 clips[CLIP_LEFT][2] = 0.0f;
 clips[CLIP_LEFT][3] = -1.0f * obj[0]->pos.x;
 
 clips[CLIP_RIGHT][0]=-1.0f;
 clips[CLIP_RIGHT][1]= 0.0f;
 clips[CLIP_RIGHT][2]= 0.0f;
 clips[CLIP_RIGHT][3]= obj[1]->pos.x;

 clips[CLIP_TOP][0]=   0.0f;
 clips[CLIP_TOP][1]=   1.0f;
 clips[CLIP_TOP][2]=   0.0f;
 clips[CLIP_TOP][3]=   -1.0f * obj[0]->pos.y;

 clips[CLIP_BOT][0]=   0.0f;
 clips[CLIP_BOT][1]=   -1.0f;
 clips[CLIP_BOT][2]=   0.0f;
 clips[CLIP_BOT][3]=   obj[1]->pos.y; 

 glClipPlane(GL_CLIP_PLANE0 + 8, clips[CLIP_LEFT]);
 glClipPlane(GL_CLIP_PLANE0 + 9, clips[CLIP_RIGHT]);
 glClipPlane(GL_CLIP_PLANE0 + 10, clips[CLIP_TOP]);
 glClipPlane(GL_CLIP_PLANE0 + 11, clips[CLIP_BOT]);
 
 glEnable(GL_CLIP_PLANE0 + 8);
 glEnable(GL_CLIP_PLANE0 + 9);
 glEnable(GL_CLIP_PLANE0 + 10);
 glEnable(GL_CLIP_PLANE0 + 11); 

 glEnable(GL_BLEND);
// glEnable(GL_DEPTH_TEST);
 glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
 glEnable(GL_TEXTURE_2D);
 glClear(GL_DEPTH_BUFFER_BIT);
 glPushMatrix(); 

 glTranslatef( (float)( ((obj[1]->pos.x - obj[0]->pos.x) / 2) + obj[0]->pos.x) , (float)( ((obj[1]->pos.y - obj[0]->pos.y) / 2) + obj[0]->pos.y), 0.0f);
 glScalef( (obj[1]->pos.x - obj[0]->pos.x) / 200.0f , (obj[1]->pos.y - obj[0]->pos.y) / 200.0f, 1.0f); 

 glMatrixMode(GL_PROJECTION);
 glPushMatrix();
 glLoadIdentity();
 gluPerspective(75, (float)d_width / (float)d_height, 1, 8000);
 
 glRotatef( rotate, 1.0f, 0.0f, 0.0f);
 
 glLoadIdentity();
  glMatrixMode(GL_MODELVIEW);

 glRotatef( rotate, 1.0f, 0.0f, 0.0f);
 //

 
 glBindTexture(GL_TEXTURE_2D, test_id);
 glBegin(GL_QUADS);
  glColor4f(1.0f, 1.0f, 1.0f, 0.3f);

  glTexCoord2f(0.0f, 0.0f); glVertex3f(-50.0f, -50.0f, 0);
  glTexCoord2f(1.0f, 0.0f); glVertex3f( 50.0f, -50.0f, 0);
  glTexCoord2f(1.0f, 1.0f); glVertex3f( 50.0f,  50.0f, 0);
  glTexCoord2f(0.0f, 1.0f); glVertex3f(-50.0f,  50.0f, 0);
 
  glTexCoord2f(0.0f, 0.0f); glVertex3f(-50.0f, -50.0f, 0);
  glTexCoord2f(1.0f, 0.0f); glVertex3f( 50.0f, -50.0f, 0);
  glTexCoord2f(1.0f, 1.0f); glVertex3f( 50.0f, -50.0f, -50.0);
  glTexCoord2f(0.0f, 1.0f); glVertex3f(-50.0f, -50.0f, -50.0);

  
 glEnd();

 glPopMatrix();
 glMatrixMode(GL_MODELVIEW);
 glMatrixMode(GL_PROJECTION);
 
 glPopMatrix();

*/
 
 glDisable(GL_CLIP_PLANE0 + 8);
 glDisable(GL_CLIP_PLANE0 + 9);
 glDisable(GL_CLIP_PLANE0 + 10);
 glDisable(GL_CLIP_PLANE0 + 11); 
}

