/*
                 ,----------------, 
           ,-----------------------,
         ,"                      ,"|
        +-----------------------+  |
        |  .-----------------.  |  |
        |  |                 |  |  | 
        |  | Hack the Gibson |  |  |
        |- |      TERM       |  |  |
        |- |                 |  |  | 
        |- |                 |  |  | 
        |- `-----------------'  |,"
        +-----------------------+
           /_)______________(_/
      _______________________________ 
     /  oooooooooooooooo  .o.  oooo /|
    / ==ooooooooooooooo==.o.  ooo= // 
   /_==__==========__==_ooo__ooo=_/'
   `-----------------------------'

  Hack the Gibson TERM is GNU software
   please read ../COPYING for details

hgterm by Thea DeSilva
*/

#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <GL/gl.h>
#include <SDL.h>
#include <SDL_image.h>

#include "err.h"
#include "util.h"

int t_tid[1024];

/* send mem to opengl. Mem is assumed to be RGB 3 bytes per pixel */

int t_mem2tex(void *mem, int x, int y, int *id) {
 
 glGenTextures(1, id);
 glBindTexture(GL_TEXTURE_2D, *id);
 glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, x,y, 0, GL_RGB, GL_UNSIGNED_BYTE,
	      (unsigned char *)mem);
 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
 return 1;
}

/* Load image and send the texture to opengl */

int t_file2tex(char *filename, int *id) {
 SDL_Surface *image;
 unsigned char *dat;
 int c;
 image = file2surface(filename);
 if(!image) {
  e_push("file2surface");
  return 0;
 }

 dat = surface2rgb(image, &c);
 if(!dat) return 0;
 t_mem2tex((void *)dat, image->w, image->h, id);
 if(c==1) free(dat);
 SDL_FreeSurface(image);
 return 1;
}


